// Decodierung und Sprechen der Datums- und Zeitinformationen von DS1307
// DFPlayer an #4,#5; Busy-Signal an Port #2

 #include <string.h>
 #include <ctype.h>
 #include <DFPlayer_Mini_Mp3.h>
 #include <avr/pgmspace.h>
 #include <SoftwareSerial.h>;
 #include <Wire.h>    
 #include "RTClib.h"  

 RTC_DS1307 RTC;      

SoftwareSerial mySerial(4, 5); // RX, TX  MP3-Player Module

int zeit, time_h, time_m, time_s, date_d, date_m, date_y;
int wochentag;
int ledPin = 13;                  // LED test pin
String DOW;
boolean stringComplete = false;

int buusyPin = 2;// buusyPin = 2; // sound player busy
int bsy = 0;
int z = 0;

///////////////////////////////////////////////////////// 
void setup()
{
  Wire.begin();  // Initialisiere I2C  
  RTC.begin();   // Initialisiere RTC

  Serial.begin(9600); // Kommunikation
  Serial.println("WAITING FOR CLOCK DATA!");
  delay(100);

  pinMode(14, INPUT_PULLUP); // A0 as input
  pinMode(15, INPUT_PULLUP); // A1 as input
  pinMode(16, INPUT_PULLUP); // A2 as input   
  pinMode(17, INPUT_PULLUP); // A3 as input    

   mySerial.begin (9600);       // data rate sound module  
   mp3_set_serial (&mySerial);	// softwareSerial for MP3-Player 
   delay(100);
   mp3_play (91);               // speak startmessage
   delay(3000);
//   mp3_play (94);               // speak info
//   delay(3000);
}

/////////////////////////////////////////////////////////// 
void loop()
{
  int sensorVal1 = digitalRead(14);  
  int sensorVal2 = digitalRead(15);  
  int sensorVal3 = digitalRead(16);  
  int sensorVal4 = digitalRead(17);  

  DateTime now=RTC.now();   // aktuelle Zeit abrufen
  show_time_and_date(now);  // Datum und Uhrzeit ausgeben 
  speak_time_and_date(); 
//  delay(10000);             // 10 Sekunden warten bis zur nächsten Ausgabe
}
  
////////////////////////////////////////////////////////////////
// Datum und Uhrzeit ausgeben
void show_time_and_date(DateTime datetime)
{

// Wochentag
//  Serial.print(get_day_of_week(datetime.dayOfWeek()));
//  Serial.print(", ");

  wochentag=(datetime.dayOfWeek()); // Wochentag
  date_d=(datetime.day());          // Tag
  date_m=(datetime.month());        // Monat
  date_y=(datetime.year());         // Jahr
  time_h=(datetime.hour());         // Stunde
  time_m=(datetime.minute());       // Minute
  time_s=(datetime.second());       // Sekunde

  day_of_week();               // Wochentag 
  Serial.print(DOW);
  Serial.print(", ");
  
  if(datetime.day()<10)Serial.print(0);
  Serial.print(date_d);
  Serial.print(".");
  if(datetime.month()<10)Serial.print(0);
  Serial.print(date_m);  
  Serial.print(".");
  Serial.println(date_y);

  if(datetime.hour()<10)Serial.print(0);
  Serial.print(time_h);
  Serial.print(":");
  if(datetime.minute()<10)Serial.print(0);
  Serial.print(time_m);
  Serial.print(":");
  if(datetime.second()<10)Serial.print(0);
  Serial.println(time_s);
}

/////////////////////////////////////////////////////////////
void speak_time_and_date()
 {

// speak day
 mp3_play(98);                // "Heute ist"
 waitend();
 speak_dow();                 // <Wochentag> 
 mp3_play(99);                // "der"  
 waitend();
 speak_day();                 // <Tag> 
 speak_month();               // <Monat>
 mp3_play(120);               // "Zwanzig"  
 waitend();
 speak_year();                // <Jahr>

// speak time
 mp3_play(95);                // "Die Uhrzeit ist"
 waitend();
 zeit = time_h;
 speak_time();                // <Stunde>
 mp3_play(90);                // "Uhr"
 waitend();
 zeit = time_m;
 speak_time();                //  <Minute>
 mp3_play(97);                // "und"
 waitend();
 zeit = time_s;
 speak_time();                // <Sekunden>
 mp3_play(96);                // "Sekunden"
 waitend();
 delay(10000);
 }

/////////////////////////////////////////////////////////////
void day_of_week()
  {
  if(wochentag==0) { DOW = "So"; } else
  if(wochentag==1) { DOW = "Mo"; } else
  if(wochentag==2) { DOW = "Di"; } else
  if(wochentag==3) { DOW = "Mi"; } else
  if(wochentag==4) { DOW = "Do"; } else
  if(wochentag==5) { DOW = "Fr"; } else
  if(wochentag==6) { DOW = "Sa"; } 
  }
  
/////////////////////////////////////////////////////////////////////
void speak_time()
{
mp3_play(zeit+100);
waitend();
}

///////////////////////////////////////////////////////////////////////////////
void speak_day()
{
mp3_play(date_d+200); 
waitend();
}

///////////////////////////////////////////////////////////////////////////////
void speak_month()
{
mp3_play(date_m+240); 
waitend();  // 1-12  
}

///////////////////////////////////////////////////////////////////////////////
void speak_year()
{
mp3_play(date_y-1900); 
waitend();  // <59
}

/////////////////////////////////////////////////////////////////
void speak_dow()
{
mp3_play(wochentag+80); 
waitend(); 
}

//////////////////////////////////////////////////////////////////////////////
void waitend()
{   
  int bsyflag = 0;
  for ( z = 0; z <= 10000; z++) {
    bsy = digitalRead(buusyPin);
    delay(50);
    if (bsyflag == 1 && bsy == 1) {
      break;
    }
    if (bsy == 0) {
      bsyflag = 1;
    }
  }  
}

