// Decodierung und Sprechen von GPS-Datums- und Zeitinformationen  

 #include <string.h>
 #include <ctype.h>
 #include <DFPlayer_Mini_Mp3.h>
 #include <avr/pgmspace.h>
 #include <SoftwareSerial.h>;

SoftwareSerial mySerial(4, 5); // RX, TX  MP3-Player Module

int buusyPin = 2;// buusyPin = 2; // sound player busy
int bsy = 0;
int z = 0;

String GPSStringbuf = "";
String zeit = "";
String date = "";
String GPSString = "";
String time, time_h, time_m, time_s;
String date_d, date_m, date_y;
int wert, _hour, _minute, _second;
int _day, _month, _year;
int ledPin = 13;                  // LED test pin
int mrk;
boolean stringComplete = false;
char floatbuf[32];
char gradbuf[4];

///////////////////////////////////////////////////////// 
void setup()
{
  Serial.begin(9600); // Kommunikation
  Serial.println("WAITING FOR DATA!");
  delay(100);
  GPSString.reserve(100); // reserviert 100 Zeichen

  pinMode(14, INPUT_PULLUP); // A0 as input
  pinMode(15, INPUT_PULLUP); // A1 as input
  pinMode(16, INPUT_PULLUP); // A2 as input   Zeit + 1 Stunde ( MEZ )
  pinMode(17, INPUT_PULLUP); // A3 as input   Zeit + 2 Stunden ( MESZ ) 

   mySerial.begin (9600);         
   mp3_set_serial (&mySerial);	 
   delay(100);
   mp3_play (91);              // speak startmessage
   delay(3000);
   mp3_play (94);              // speak info
   delay(3000);
}

/////////////////////////////////////////////////////////// 
void loop()
{
  while (Serial.available()) 
  {
    char inChar = (char)Serial.read(); 
    GPSString += inChar;
    if (inChar == '\n') {
    stringComplete = true;
    }
  }
  if (stringComplete) 
  {    
    if(GPSString.indexOf("$GPRMC") != -1) 
    {
      GPSString.replace("$GPRMC,", ""); 

  int sensorVal1 = digitalRead(14);  
  int sensorVal2 = digitalRead(15);  
  int sensorVal3 = digitalRead(16);  
  int sensorVal4 = digitalRead(17);  

//----------------Zeit-----------------------------------------------------------------------
  
  time_h = GPSString.substring(0, 2);  
  _hour =   (time_h.toInt());

// -------------- Stundenkorrektur ------------------- 
 if(sensorVal3 == LOW) 
 { _hour = _hour + 1;
   if(_hour==24) { _hour=0; }  
 }                                 // add 1 Stunde ( MEZ )       
   else
 if(sensorVal4 == LOW) 
 { _hour = _hour + 2;
   if(_hour==24) { _hour=0; }  
   else
   if(_hour==25) { _hour=1; }  
 }                                 // add 2 Stunden ( MESZ ) 
   else
 { _hour = _hour; }                // add 0 Sunden ( GMT )  
  
  time_m = GPSString.substring(2, 4);
  time_s = GPSString.substring(4, 6);

//----------------Date----------------------------------------------------------------      
  GPSStringbuf = GPSString.substring(position(8), position(9) - 1); 
 
  date_d = GPSStringbuf.substring(0, 2);  
  date_m = GPSStringbuf.substring(2, 4);
  date_y = GPSStringbuf.substring(4, 6);

  _minute = (time_m.toInt());
  _second = (time_s.toInt());
  
  _day = (date_d.toInt());
  _month = (date_m.toInt());
  _year = (date_y.toInt());

  if(_hour<10) {Serial.print("0"); }
  Serial.print(_hour);
  Serial.print(":");
  if(_minute<10) {Serial.print("0"); }
  Serial.print(_minute);
  Serial.print(":");
  if(_second<10) {Serial.print("0"); }
  Serial.println(_second);

  Serial.print(_day);
  Serial.print(".");
  Serial.print(_month);
  Serial.print(".20");
  Serial.println(_year);

//////////////  Sprechen des Datums und des Zeitwertes ///////////////  
if (sensorVal1 == LOW) 
 { 
 mp3_play(98);                   // speak "Heute ist"   
 waitend();
 mp3_play(99);                   // speak "der"   
 waitend();
 speak_day();                    // speak Tag 
 speak_month();                  // speak Monat 
 mp3_play(120);
 waitend(); 
 speak_year();                   // speak "Jahr" 
 delay(1000);
 
 mp3_play(95);                  // speak "Die Uhrzeit ist"   
 waitend(); 
 wert = _hour;
 speak_time();                  // speak Stundenwerte      
 mp3_play(90);                  // speak "Uhr"         
 waitend();
 wert = _minute;                   
 speak_time();                  // speak Minutenwerte 
 mp3_play(97);                  // speak "und"
 waitend(); 
 wert = _second; 
 speak_time();                  // speak sekundenwerte
 mp3_play(96);                  // speak "Sekunden"
 delay(1400); 
 }                          

////////////// Sprechen der Zeitwertes bei Minutenbeginn //////////////       
if (sensorVal2 == HIGH) 
 { 
if(_second==0) 
 { wert=_hour;
   speak_time();                  // speak Stundenwerte      
   mp3_play(90);                  // speak "Uhr"         
   waitend();
   wert=_minute;                   
   speak_time();                   // speak Minutenwerte
   }                 
 }
}
    GPSString = "";
    stringComplete = false;
 }
}

/////////////////////////////////////////////////////////////////////////////////////////// 
int position(int number) 
{
  int i = 0;
  int position = 0;
  while(i < number)
  {
    position = GPSString.indexOf(",", position) + 1; 
    i++;
  }
  return position;
}

/////////////////////////////////////////////////////////////////////
void speak_time()  // 0-59 
{
 mp3_play(wert+100);
 waitend();
}

///////////////////////////////////////////////////////////////////////////////
void speak_day()   // 1-31
{
mp3_play(_day+200); 
waitend();
}

///////////////////////////////////////////////////////////////////////////////
void speak_month()  // 1-12 
{
mp3_play(_month+240);
waitend();    
}

///////////////////////////////////////////////////////////////////////////////
void speak_year()   // 0-59
{
mp3_play(_year+100);
waitend();  
}

//////////////////////////////////////////////////////////////////////////////
void waitend()
{   
  int bsyflag = 0;
  for ( z = 0; z <= 10000; z++) {
    bsy = digitalRead(buusyPin);
    delay(50);
    if (bsyflag == 1 && bsy == 1) {
      break;
    }
    if (bsy == 0) {
      bsyflag = 1;
    }
  }  
}

